package algae.gui;

import javax.swing.JOptionPane;
import javax.swing.JDialog;
import javax.swing.JTextField;
import java.beans.*; 
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.lang.Integer;
import java.lang.String;

class CustomDialog extends JDialog {
    private String typedText = null;

    private int retVal=0;
    private String magicWord;
    private JOptionPane optionPane;

    public String getValidatedText() 
    {
        return typedText;
    }
  
    public int getResult()
    {
    	return retVal;
    }

    public CustomDialog(Frame aFrame, int steps, ContinueDlg parent) 
    {
        super(aFrame, true);
        final ContinueDlg dd = parent;

        setTitle("Simulation finished");

        final String msgString1 = "The simulation has finished after "+steps+" steps,";
        final String msgString2 = "If you want to continue, enter number of steps to simulate:";
        final JTextField textField = new JTextField(10);
        Object[] array = {msgString1, msgString2, textField};

        final String btnString1 = "Continue";
        final String btnString2 = "Cancel";
        Object[] options = {btnString1, btnString2};

        optionPane = new JOptionPane(array, 
                                    JOptionPane.QUESTION_MESSAGE,
                                    JOptionPane.YES_NO_OPTION,
                                    null,
                                    options,
                                    options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                optionPane.setValue(new Integer(JOptionPane.CLOSED_OPTION));
            }
        });

        textField.addActionListener(new ActionListener() 
        {
            public void actionPerformed(ActionEvent e) {
                optionPane.setValue(btnString1);
            }
        });

        optionPane.addPropertyChangeListener(new PropertyChangeListener() 
        {
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();

                if (isVisible()&&(e.getSource() == optionPane)&& 
                    (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) 
                {
                    Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) 
                    {
                        return;
                    }

                    optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);

                    if (value.equals(btnString1)) 
                    {
                    	int err=0;
                        typedText = textField.getText();
                        
                        try {
                           retVal=Integer.parseInt(typedText);
                        } catch (NumberFormatException ef)
                        {
                           err=1;
                           System.out.println("EXCEPTION: Number conversion");
                        }
                        
                        if ((err==0)&&(retVal<1))
                           err=1;
                           
                        if (err==1)
                        {
                            JOptionPane.showMessageDialog(CustomDialog.this,
                                   "Please enter only valid numbers >0.",
                                   "Input error",
                                   JOptionPane.ERROR_MESSAGE);
                	}
                	else
                	{                                               
                       	   setVisible(false);
                       	}
                    } 
                    else 
                    { 
                        typedText = null;
                        retVal=-1;
                        setVisible(false);
                    }
                }
            }
        });
    }
}
