package algae.simulation;

public final class Settings {
    
    // simulation settings
    public int duration; // duration of simulation in steps
    public int width;    // width of aquarium
    public int height;   // height of aquarium

    public int randSeed; // random seed

    public int light_enabled; // never (0), always (1), function (2)
    public float light_intensity; // intensity of light

    public int light_function; // not implemented yet
    public int light_cycle_function; // not implmented yet
    
    public int substrate_amount; // amount of substrate at the beginning 
    public float substrate_renew_rate; // renew rate of substrate
    public float pheromone_dec_rate;   // decrease rate of pheromone

    // algaes settings
    public int initial_algaes; // how many algaes arte there at the beginning
    public float initial_energy; // how much energy (0.0-1.0) at the beginning

    // senors settings
    public int pheromone_fov; // FOV of pheromone sensor
    public int pheromone_range; // range of sight of pheromone sensor
    public int substrate_fov; // FOV of substrate sensor
    public int substrate_range; // range of sight of substrate sensor
    public int light_fov; // FOV of light sensor
    public int light_range; // range of sight of light sensor
    public int bumper_range; // range of sight of bumper sensor

    // actions settings
    // -- using energy
    public float energy_movement; // energy needed for movement
    public float energy_mitose; // energy needed for mitose
    public float energy_meiose; // energy needed for meiose
    public float energy_pheromone_output; // energy needed for pheromone output

    // -- collecting energy
    public float energy_substrate; // energy the algae gets for substrate
    public float energy_light; // energy the algae gets for light
}
